<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Lifinity Dungeon: cpp_filrouge_iscj_allemann/include/Utility.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Lifinity Dungeon
   &#160;<span id="projectnumber">6</span>
   </div>
   <div id="projectbrief">The Lifinity Dungeon is a dungeon with an infinity of room. After each room, you found a harder room. This is why you will pass the eternity of your life in this dungeon</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_7b4dd9274471389300495e9c763ca813.html">cpp_filrouge_iscj_allemann</a></li><li class="navelem"><a class="el" href="dir_e5b3fe71963387781ba01d2a56ee1874.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Utility.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_utility_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;sstream&gt;</span> <span class="comment">// stringstream</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;iomanip&gt;</span> <span class="comment">// padding setw</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;tuple&gt;</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &lt;chrono&gt;</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &lt;list&gt;</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &lt;algorithm&gt;</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">namespace </span>He_Arc::RPG</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;{</div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_utility.html">   39</a></span>&#160;    <span class="keyword">class </span><a class="code" href="class_he___arc_1_1_r_p_g_1_1_utility.html">Utility</a></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    {</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keyword">private</span>:</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> NB_LINE_CLEARING_SCREEN{20};</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <a class="code" href="class_he___arc_1_1_r_p_g_1_1_utility.html">Utility</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160; </div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        <span class="keyword">typedef</span> tuple&lt;int, int, int, int, int, int&gt; dtTuple;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        <span class="keyword">virtual</span> ~<a class="code" href="class_he___arc_1_1_r_p_g_1_1_utility.html">Utility</a>() = <span class="keywordflow">default</span>; <span class="comment">//Make the class abstract</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="comment"></span>        <span class="keyword">static</span> <span class="keywordtype">void</span> ClearTerminal();</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> WaitEnterForContinue(<span class="keywordtype">bool</span> showMsg = <span class="keyword">true</span>);</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">string</span> LeftPadding(<span class="keywordtype">int</span> totalLength, <span class="keywordtype">string</span> text);</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">string</span> LeftPadding(<span class="keywordtype">int</span> totalLength, <span class="keywordtype">char</span> character);</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">string</span> TabShift(<span class="keywordtype">int</span> qty);</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">string</span> CenterTextWithSpace(<span class="keywordtype">int</span> length, <span class="keywordtype">string</span> text);</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">string</span> GetBorder(<span class="keywordtype">int</span> length, <span class="keywordtype">string</span> border);</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">string</span> GetTextLine(<span class="keywordtype">int</span> length, <span class="keywordtype">string</span> border, <span class="keywordtype">string</span> text, <span class="keywordtype">bool</span> center = <span class="keyword">false</span>);</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <span class="keyword">static</span> dtTuple GetDateTimeFromSysClock(<span class="keyword">const</span> chrono::system_clock::time_point clock);</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">string</span> dtTupleToString(dtTuple dt);</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00149"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_utility.html#a51b62483a99745fed9691dae9316a79a">  149</a></span>&#160;        <span class="keyword">static</span> list&lt;T&gt; <a class="code" href="class_he___arc_1_1_r_p_g_1_1_utility.html#a51b62483a99745fed9691dae9316a79a">VectToList</a>(vector&lt;T&gt; src)</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        {</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;            std::list&lt;T&gt; dest;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;            dest.insert(dest.begin(), src.begin(), src.end());</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160; </div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;            <span class="keywordflow">return</span> dest;</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        }</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160; </div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00165"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_utility.html#ae198c4ca91f71de1174a1b6e4ca1f6f6">  165</a></span>&#160;        <span class="keyword">static</span> vector&lt;T&gt; <a class="code" href="class_he___arc_1_1_r_p_g_1_1_utility.html#ae198c4ca91f71de1174a1b6e4ca1f6f6">distinctVector</a>(vector&lt;T&gt; source)</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        {</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;            <span class="comment">//https://en.cppreference.com/w/cpp/algorithm/unique</span></div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;            sort(source.begin(), source.end());</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;            source.erase(unique(source.begin(), source.end()), source.end());</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160; </div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;            <span class="keywordflow">return</span> source;</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        }</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    };</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;} <span class="comment">// namespace He_Arc::RPG</span></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_utility_html"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_utility.html">He_Arc::RPG::Utility</a></div><div class="ttdoc">This class contains statics methods qualified as utility (not specific to 1 class)</div><div class="ttdef"><b>Definition:</b> Utility.hpp:40</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_utility_html_a51b62483a99745fed9691dae9316a79a"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_utility.html#a51b62483a99745fed9691dae9316a79a">He_Arc::RPG::Utility::VectToList</a></div><div class="ttdeci">static list&lt; T &gt; VectToList(vector&lt; T &gt; src)</div><div class="ttdoc">Convert a vector to list.</div><div class="ttdef"><b>Definition:</b> Utility.hpp:149</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_utility_html_ae198c4ca91f71de1174a1b6e4ca1f6f6"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_utility.html#ae198c4ca91f71de1174a1b6e4ca1f6f6">He_Arc::RPG::Utility::distinctVector</a></div><div class="ttdeci">static vector&lt; T &gt; distinctVector(vector&lt; T &gt; source)</div><div class="ttdoc">Get a copy of the vector with unique value (remove duplicate) (copy will be ordered)</div><div class="ttdef"><b>Definition:</b> Utility.hpp:165</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
